package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLPWAff_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLPWAff extends JNIObject implements IISLSingleSpaceReadOnlyMapMethods {
	
	/* @generated */
	protected ISLPWAff(long ptr) {
		/*** PROTECTED REGION ID(ISLPWAff_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLPWAff build(long ptr) {
		return new ISLPWAff(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLPWAff_userCode) ENABLED START ***/
	public String toString(ISL_FORMAT format) {
		return ISLPrettyPrinter.asString(this, format);
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_pw_aff_read_from_str 
	 * 
	 * @generated
	**/
	 public static ISLPWAff buildFromString(ISLContext ctx, String str) { 
		/*** PROTECTED REGION ID(static_isl_pw_aff_read_from_str) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_read_from_str(getNativePtr(ctx), str));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_alloc 
	 * 
	@take set aff
	 * @generated
	**/
	 public static ISLPWAff build(ISLSet set, ISLAff aff) { 
		/*** PROTECTED REGION ID(static_isl_pw_aff_alloc) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(set, aff);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_alloc(getNativePtr(set), getNativePtr(aff)));
			} finally {
				taken(set);
				taken(aff);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_empty 
	 * 
	@take dim
	 * @generated
	**/
	 public static ISLPWAff buildEmpty(ISLSpace dim) { 
		/*** PROTECTED REGION ID(static_isl_pw_aff_empty) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(dim);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_empty(getNativePtr(dim)));
			} finally {
				taken(dim);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_zero_on_domain 
	 * 
	@take ls
	 * @generated
	**/
	 public static ISLPWAff buildZeroOnDomain(ISLLocalSpace ls) { 
		/*** PROTECTED REGION ID(static_isl_pw_aff_zero_on_domain) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(ls);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_zero_on_domain(getNativePtr(ls)));
			} finally {
				taken(ls);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_var_on_domain 
	 * 
	@take ls
	 * @generated
	**/
	 public static ISLPWAff buildVarOnDomain(ISLLocalSpace ls, ISLDimType type, int pos) { 
		/*** PROTECTED REGION ID(static_isl_pw_aff_var_on_domain) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(ls);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_var_on_domain(getNativePtr(ls), type.getValue(), pos));
			} finally {
				taken(ls);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_nan_on_domain 
	 * 
	@take ls
	 * @generated
	**/
	 public static ISLPWAff buildNaNOnDomain(ISLLocalSpace ls) { 
		/*** PROTECTED REGION ID(static_isl_pw_aff_nan_on_domain) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(ls);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_nan_on_domain(getNativePtr(ls)));
			} finally {
				taken(ls);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLPWAff pwa, int format) { 
		/*** PROTECTED REGION ID(static_isl_pw_aff_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_pw_aff_to_string(getNativePtr(pwa), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_multi_pw_aff_from_pw_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiPWAff toMultiPWAff() {
		/*** PROTECTED REGION ID(isl_multi_pw_aff_from_pw_aff) DISABLED START ***/
		ISLMultiPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiPWAff.build(ISLNative.isl_multi_pw_aff_from_pw_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_multi_aff_from_pw_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPWMultiAff toPWMultiAff() {
		/*** PROTECTED REGION ID(isl_pw_multi_aff_from_pw_aff) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_pw_multi_aff_from_pw_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_from_pw_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionPWAff toUnionPWAff() {
		/*** PROTECTED REGION ID(isl_union_pw_aff_from_pw_aff) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_from_pw_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_from_pw_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet toSet() {
		/*** PROTECTED REGION ID(isl_set_from_pw_aff) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_from_pw_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_from_pw_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap toMap() {
		/*** PROTECTED REGION ID(isl_map_from_pw_aff) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_from_pw_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_pw_aff_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_pw_aff_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_get_space 
	 * 
	 * @generated
	**/
	public ISLSpace getSpace() {
		/*** PROTECTED REGION ID(isl_pw_aff_get_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_pw_aff_get_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_get_domain_space 
	 * 
	 * @generated
	**/
	public ISLSpace getDomainSpace() {
		/*** PROTECTED REGION ID(isl_pw_aff_get_domain_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_pw_aff_get_domain_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_copy 
	 * 
	 * @generated
	**/
	public ISLPWAff copy() {
		/*** PROTECTED REGION ID(isl_pw_aff_copy) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_pw_aff_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_pw_aff_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_get_dim_name 
	 * 
	 * @generated
	**/
	public String getDimName(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_pw_aff_get_dim_name) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_pw_aff_get_dim_name(getNativePtr(this), type.getValue(), pos);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_is_empty 
	 * 
	 * @generated
	**/
	public boolean isEmpty() {
		/*** PROTECTED REGION ID(isl_pw_aff_is_empty) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_pw_aff_is_empty(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_involves_nan 
	 * 
	 * @generated
	**/
	public boolean involvesNaN() {
		/*** PROTECTED REGION ID(isl_pw_aff_involves_nan) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_pw_aff_involves_nan(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_plain_is_equal 
	 * 
	 * @generated
	**/
	public boolean isPlainEqual(ISLPWAff pwaff2) {
		/*** PROTECTED REGION ID(isl_pw_aff_plain_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_pw_aff_plain_is_equal(getNativePtr(this), getNativePtr(pwaff2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_is_equal 
	 * 
	 * @generated
	**/
	public boolean isEqual(ISLPWAff pa2) {
		/*** PROTECTED REGION ID(isl_pw_aff_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_pw_aff_is_equal(getNativePtr(this), getNativePtr(pa2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_dim 
	 * 
	 * @generated
	**/
	public int dim(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_pw_aff_dim) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_pw_aff_dim(getNativePtr(this), type.getValue());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_involves_dims 
	 * 
	 * @generated
	**/
	public boolean involvesDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_pw_aff_involves_dims) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_pw_aff_involves_dims(getNativePtr(this), type.getValue(), first, n) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_is_cst 
	 * 
	 * @generated
	**/
	public boolean isConstant() {
		/*** PROTECTED REGION ID(isl_pw_aff_is_cst) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_pw_aff_is_cst(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_align_params 
	 * 
	 * @take this model
	 * @generated
	**/
	public ISLPWAff islPwAffAlignParams(ISLSpace model) {
		/*** PROTECTED REGION ID(isl_pw_aff_align_params) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, model);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_align_params(getNativePtr(this), getNativePtr(model)));
			} finally {
				taken(this);
				taken(model);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_params 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet params() {
		/*** PROTECTED REGION ID(isl_pw_aff_params) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_pw_aff_params(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_domain 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet domain() {
		/*** PROTECTED REGION ID(isl_pw_aff_domain) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_pw_aff_domain(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_from_range 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPWAff fromRange() {
		/*** PROTECTED REGION ID(isl_pw_aff_from_range) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_from_range(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_min 
	 * 
	 * @take this pwaff2
	 * @generated
	**/
	public ISLPWAff min(ISLPWAff pwaff2) {
		/*** PROTECTED REGION ID(isl_pw_aff_min) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, pwaff2);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_min(getNativePtr(this), getNativePtr(pwaff2)));
			} finally {
				taken(this);
				taken(pwaff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_max 
	 * 
	 * @take this pwaff2
	 * @generated
	**/
	public ISLPWAff max(ISLPWAff pwaff2) {
		/*** PROTECTED REGION ID(isl_pw_aff_max) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, pwaff2);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_max(getNativePtr(this), getNativePtr(pwaff2)));
			} finally {
				taken(this);
				taken(pwaff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_mul 
	 * 
	 * @take this pwaff2
	 * @generated
	**/
	public ISLPWAff mul(ISLPWAff pwaff2) {
		/*** PROTECTED REGION ID(isl_pw_aff_mul) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, pwaff2);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_mul(getNativePtr(this), getNativePtr(pwaff2)));
			} finally {
				taken(this);
				taken(pwaff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_div 
	 * 
	 * @take this pa2
	 * @generated
	**/
	public ISLPWAff div(ISLPWAff pa2) {
		/*** PROTECTED REGION ID(isl_pw_aff_div) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, pa2);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_div(getNativePtr(this), getNativePtr(pa2)));
			} finally {
				taken(this);
				taken(pa2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_add 
	 * 
	 * @take this pwaff2
	 * @generated
	**/
	public ISLPWAff add(ISLPWAff pwaff2) {
		/*** PROTECTED REGION ID(isl_pw_aff_add) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, pwaff2);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_add(getNativePtr(this), getNativePtr(pwaff2)));
			} finally {
				taken(this);
				taken(pwaff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_sub 
	 * 
	 * @take this pwaff2
	 * @generated
	**/
	public ISLPWAff sub(ISLPWAff pwaff2) {
		/*** PROTECTED REGION ID(isl_pw_aff_sub) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, pwaff2);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_sub(getNativePtr(this), getNativePtr(pwaff2)));
			} finally {
				taken(this);
				taken(pwaff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_neg 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPWAff neg() {
		/*** PROTECTED REGION ID(isl_pw_aff_neg) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_neg(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_ceil 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPWAff ceil() {
		/*** PROTECTED REGION ID(isl_pw_aff_ceil) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_ceil(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_floor 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPWAff floor() {
		/*** PROTECTED REGION ID(isl_pw_aff_floor) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_floor(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_mod_val 
	 * 
	 * @take this mod
	 * @generated
	**/
	public ISLPWAff mod(ISLVal mod) {
		/*** PROTECTED REGION ID(isl_pw_aff_mod_val) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, mod);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_mod_val(getNativePtr(this), getNativePtr(mod)));
			} finally {
				taken(this);
				taken(mod);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_union_min 
	 * 
	 * @take this pwaff2
	 * @generated
	**/
	public ISLPWAff unionMin(ISLPWAff pwaff2) {
		/*** PROTECTED REGION ID(isl_pw_aff_union_min) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, pwaff2);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_union_min(getNativePtr(this), getNativePtr(pwaff2)));
			} finally {
				taken(this);
				taken(pwaff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_union_max 
	 * 
	 * @take this pwaff2
	 * @generated
	**/
	public ISLPWAff unionMax(ISLPWAff pwaff2) {
		/*** PROTECTED REGION ID(isl_pw_aff_union_max) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, pwaff2);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_union_max(getNativePtr(this), getNativePtr(pwaff2)));
			} finally {
				taken(this);
				taken(pwaff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_union_add 
	 * 
	 * @take this pwaff2
	 * @generated
	**/
	public ISLPWAff unionAdd(ISLPWAff pwaff2) {
		/*** PROTECTED REGION ID(isl_pw_aff_union_add) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, pwaff2);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_union_add(getNativePtr(this), getNativePtr(pwaff2)));
			} finally {
				taken(this);
				taken(pwaff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_intersect_params 
	 * 
	 * @take this set
	 * @generated
	**/
	public ISLPWAff intersectParams(ISLSet set) {
		/*** PROTECTED REGION ID(isl_pw_aff_intersect_params) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, set);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_intersect_params(getNativePtr(this), getNativePtr(set)));
			} finally {
				taken(this);
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_intersect_domain 
	 * 
	 * @take this set
	 * @generated
	**/
	public ISLPWAff intersectDomain(ISLSet set) {
		/*** PROTECTED REGION ID(isl_pw_aff_intersect_domain) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, set);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_intersect_domain(getNativePtr(this), getNativePtr(set)));
			} finally {
				taken(this);
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_intersect_domain_wrapped_domain 
	 * 
	 * @take this set
	 * @generated
	**/
	public ISLPWAff intersectDomainWrappedDomain(ISLSet set) {
		/*** PROTECTED REGION ID(isl_pw_aff_intersect_domain_wrapped_domain) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, set);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_intersect_domain_wrapped_domain(getNativePtr(this), getNativePtr(set)));
			} finally {
				taken(this);
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_intersect_domain_wrapped_range 
	 * 
	 * @take this set
	 * @generated
	**/
	public ISLPWAff intersectDomainWrappedRange(ISLSet set) {
		/*** PROTECTED REGION ID(isl_pw_aff_intersect_domain_wrapped_range) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, set);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_intersect_domain_wrapped_range(getNativePtr(this), getNativePtr(set)));
			} finally {
				taken(this);
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_scale_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLPWAff scale(ISLVal v) {
		/*** PROTECTED REGION ID(isl_pw_aff_scale_val) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_scale_val(getNativePtr(this), getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_scale_down_val 
	 * 
	 * @take this f
	 * @generated
	**/
	public ISLPWAff scaleDown(ISLVal f) {
		/*** PROTECTED REGION ID(isl_pw_aff_scale_down_val) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, f);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_scale_down_val(getNativePtr(this), getNativePtr(f)));
			} finally {
				taken(this);
				taken(f);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_insert_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPWAff insertDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_pw_aff_insert_dims) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_insert_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_add_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPWAff addDims(ISLDimType type, int n) {
		/*** PROTECTED REGION ID(isl_pw_aff_add_dims) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_add_dims(getNativePtr(this), type.getValue(), n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_move_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPWAff moveDims(ISLDimType dst_type, int dst_pos, ISLDimType src_type, int src_pos, int n) {
		/*** PROTECTED REGION ID(isl_pw_aff_move_dims) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_move_dims(getNativePtr(this), dst_type.getValue(), dst_pos, src_type.getValue(), src_pos, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_drop_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPWAff dropDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_pw_aff_drop_dims) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_drop_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_coalesce 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPWAff coalesce() {
		/*** PROTECTED REGION ID(isl_pw_aff_coalesce) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_coalesce(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_gist 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLPWAff gist(ISLSet context) {
		/*** PROTECTED REGION ID(isl_pw_aff_gist) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLPWAff.build(ISLNative.isl_pw_aff_gist(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_eval 
	 * 
	 * @take this pnt
	 * @generated
	**/
	public ISLVal eval(ISLPoint pnt) {
		/*** PROTECTED REGION ID(isl_pw_aff_eval) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters(this, pnt);
			try {
				res = ISLVal.build(ISLNative.isl_pw_aff_eval(getNativePtr(this), getNativePtr(pnt)));
			} finally {
				taken(this);
				taken(pnt);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_pw_aff_n_piece 
	 * 
	 * @generated
	**/
	public int getNbPieces() {
		/*** PROTECTED REGION ID(isl_pw_aff_n_piece) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_pw_aff_n_piece(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLPWAff_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
